﻿using System;
using System.Data;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Storage;

namespace Butterfly.HabboHotel.Items
{
    static class TeleHandler
    {
        internal static UInt32 GetLinkedTele(UInt32 TeleId, Room pRoom)
        {
            //foreach (RoomItem Item in pRoom.FloorItems.Values)
            //{
            //    if (Item.Id == TeleId)
            //        return Item.Id;
            //}

            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                DataRow Row = dbClient.ReadDataRow("SELECT tele_two_id FROM tele_links WHERE tele_one_id = '" + TeleId + "' LIMIT 1;");

                if (Row == null)
                {
                    return 0;
                }

                return (UInt32)Row[0];
            }
        }

        internal static UInt32 GetTeleRoomId(UInt32 TeleId, Room pRoom)
        {
            foreach (RoomItem Item in pRoom.FloorItems.Values)
            {
                if (Item.Id == TeleId)
                    return pRoom.RoomId;
            }
            using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            {
                DataRow Row = dbClient.ReadDataRow("SELECT room_id FROM room_items WHERE id = '" + TeleId + "' LIMIT 1;");

                if (Row == null)
                {
                    return 0;
                }

                return (UInt32)Row[0];
            }
        }

        internal static bool IsTeleLinked(UInt32 TeleId, Room pRoom)
        {
            uint LinkId = GetLinkedTele(TeleId, pRoom);

            if (LinkId == 0)
            {
                return false;
            }

            foreach (RoomItem Item in pRoom.FloorItems.Values)
            {
                if (Item.Id == LinkId && Item.GetBaseItem().InteractionType == Butterfly_Emulator.HabboHotel.Items.InteractionType.teleport)
                    return true;
            }

            uint RoomId = GetTeleRoomId(LinkId, pRoom);

            if (RoomId == 0)
            {
                return false;
            }

            return true;
        }
    }
}
