﻿using System;
using Butterfly.HabboHotel.GameClients;
using Butterfly.Messages;

namespace Butterfly.HabboHotel.Users.Messenger
{
    class MessengerBuddy
    {
        private uint UserId;
        internal Boolean UpdateNeeded;
        private string mUsername;
        private string mLook;
        private string mMotto;
        private string mLastOnline;

        internal uint Id
        {
            get
            {
                return UserId;
            }
        }

        //internal string Username
        //{
        //    get
        //    {
        //        return mUsername;
        //    }
        //}

        //internal string RealName
        //{
        //    get
        //    {
        //        //return "";
        //        GameClient Client = UberEnvironment.GetGame().GetClientManager().GetClientByHabbo(UserId);

        //        if (Client != null)
        //        {
        //            return Client.GetHabbo().RealName;
        //        }
        //        else
        //        {
        //            using (DatabaseClient dbClient = UberEnvironment.GetDatabase().GetClient())
        //            {
        //                return dbClient.ReadString("SELECT real_name FROM users WHERE id = '" + UserId + "' LIMIT 1");
        //            }
        //        }
        //    }
        //}

        //internal string Look
        //{
        //    get
        //    {
        //        return mLook;
        //    }
        //}

        //internal string Motto
        //{
        //    get
        //    {
        //        return mMotto;
        //    }
        //}

        //internal string LastOnline
        //{
        //    get
        //    {
        //        return mLastOnline;
        //    }
        //}

        internal Boolean IsOnline
        {
            get
            {
                GameClient Client = ButterflyEnvironment.GetGame().GetClientManager().GetClientByHabbo(UserId);

                if (Client != null)
                {
                    if (Client.GetHabbo() != null)
                    {
                        if (Client.GetHabbo().GetMessenger() != null)
                        {
                            if (!Client.GetHabbo().GetMessenger().AppearOffline)
                            {
                                return true;
                            }
                        }
                    }
                }

                return false;
            }
        }

        internal Boolean InRoom
        {
            get
            {
                GameClient Client = ButterflyEnvironment.GetGame().GetClientManager().GetClientByHabbo(UserId);

                if (Client == null)
                {
                    return false;
                }

                if (Client.GetHabbo().InRoom)
                {
                    return true;
                }

                return false;
            }
        }

        internal MessengerBuddy(uint UserId, string pUsername, string pLook, string pMotto, string pLastOnline)
        {
            this.UserId = UserId;
            this.mUsername = pUsername;
            this.mLook = pLook;
            this.mMotto = pMotto;
            this.mLastOnline = pLastOnline;

            this.UpdateNeeded = false;
        }

        internal void Serialize(ServerMessage Message, Boolean Search)
        {
            if (Search)
            {
                Message.AppendUInt(this.UserId);
                Message.AppendStringWithBreak(this.mUsername);
                Message.AppendStringWithBreak(this.mMotto);

                bool Online = IsOnline;

                Message.AppendBoolean(Online);
                if (Online)
                    Message.AppendBoolean(InRoom);
                else
                    Message.AppendBoolean(false);
                
                Message.AppendStringWithBreak("");
                Message.AppendBoolean(false);
                Message.AppendStringWithBreak(this.mLook);
                Message.AppendStringWithBreak(this.mLastOnline);
                Message.AppendStringWithBreak(""); // ????????????
            }
            else
            {
                Message.AppendUInt(this.UserId);
                Message.AppendStringWithBreak(this.mUsername);
                Message.AppendBoolean(true);

                bool Online = IsOnline;

                Message.AppendBoolean(Online);
                if (Online)
                    Message.AppendBoolean(InRoom);
                else
                    Message.AppendBoolean(false);
                
                Message.AppendStringWithBreak(this.mLook);
                Message.AppendBoolean(false);
                Message.AppendStringWithBreak(this.mMotto);
                Message.AppendStringWithBreak(this.mLastOnline);
                Message.AppendStringWithBreak("");
            }
        }
    }
}
