﻿using System;

namespace Butterfly.HabboHotel.Users.Subscriptions
{
    class Subscription
    {
        private string Caption;

        //private int TimeActivated;
        private int TimeExpire;
        private int G;
        private int D;
        private int TimeInit;

        internal int Gifts
        {
            get
            {
                return G;
            }
        }

        internal int Days
        {
            get
            {
                return D;
            }
        }

        internal string SubscriptionId
        {
            get
            {
                return Caption;
            }
        }

        internal int ExpireTime
        {
            get
            {
                return TimeExpire;
            }
        }

        internal int InitialTime
        {
            get
            {
                return TimeInit;
            }
        }

        internal Subscription(string Caption, int TimeExpire, int TimeInit, int G, int D)
        {
            this.Caption = Caption;
            //this.TimeActivated = TimeActivated;
            this.TimeExpire = TimeExpire;
            this.TimeInit = TimeInit;
            this.G = G;
            this.D = D;
        }

        internal Boolean IsValid()
        {
            if (TimeExpire <= ButterflyEnvironment.GetUnixTimestamp())
            {
                return false;
            }

            return true;
        }

        internal void ExtendSubscription(int Time)
        {
            TimeExpire += Time;
        }
    }
}
