﻿using System.Collections.Generic;

namespace Butterfly_Emulator.ServerManager
{
    static class SessionManagement
    {
        private static List<Session> mSessions;

        internal static void Init()
        {
            mSessions = new List<Session>();
        }

        internal static void RegisterSession(Session pSession)
        {
            if (!mSessions.Contains(pSession))
                mSessions.Add(pSession);
        }

        internal static void RemoveSession(Session pSession)
        {
            mSessions.Remove(pSession);
        }

        internal static void IncreaseError()
        {
            foreach (Session Session in mSessions)
                Session.DisconnectionError++;
        }

        internal static void IncreaseDisconnection()
        {
            foreach (Session Session in mSessions)
                Session.Disconnection++;
        }
    }
}
