﻿
namespace Butterfly.HabboHotel.Pathfinding
{
    internal struct Coord
    {
        internal int X;
        internal int Y;

        internal Coord(int x, int y)
        {
            X = x;
            Y = y;
        }

        public static bool operator ==(Coord a, Coord b)
        {
            if (System.Object.ReferenceEquals(a, b))
            {
                return true;
            }

            if ((object)a == null || (object)b == null)
            {
                return false;
            }

            return a.X == b.X && a.Y == b.Y;
        }

        public static bool operator !=(Coord a, Coord b)
        {
            return !(a == b);
        }

        public override int GetHashCode()
        {
            return X ^ Y;
        }

        public override bool Equals(object obj)
        {
            if (obj == null)
                return false;
            else
                return base.GetHashCode().Equals(obj.GetHashCode());
        }
    }
}
