﻿using System;
using System.Net.Sockets;
using Butterfly.Core;
using System.Net;
using System.Collections.Generic;

namespace Butterfly.Net
{
    static class TcpAuthorization
    {
        //private static string[] mConnectionStorage;
        private static Dictionary<string, int> mConnectionStorage;
        private static string mLastIpBlocked;
        //private static int mMaxLoad;

        internal static void SetupTcpAuthorization(int ConnectionCount)
        {
            //mConnectionStorage = new string[ConnectionCount];
            mConnectionStorage = new Dictionary<string, int>();
        }

        internal static bool CheckConnection(Socket Sock)
        {
            string SocketIP = Sock.RemoteEndPoint.ToString().Split(':')[0];

            if (SocketIP == mLastIpBlocked)
                return false;
            else
            {
                int ConnectionAmount = GetConnectionAmount(SocketIP);
                //if (ConnectionAmount > 10)
                //{
                //    mLastIpBlocked = SocketIP;
                //    Logging.LogDDOS(SocketIP + "," + DateTime.Now.ToString());
                //    return false;
                //}
                //else
                {
                    if (mConnectionStorage.ContainsKey(SocketIP))
                        mConnectionStorage.Remove(SocketIP);

                    mConnectionStorage.Add(SocketIP, ConnectionAmount + 1);
                }
            }

            return true;
            //if (SocketIP == mLastIpBlocked)
            //{
            //    //SocketIP = null;
            //    return false;
            //}
            //else if (GetConnectionAmount(SocketIP) > 10) 
            //{
            //    //Console.WriteLine(SocketIP + " is banned.");
            //    Logging.LogDDOS(SocketIP + DateTime.Now.ToString());
            //    mLastIpBlocked = SocketIP;
            //    //SocketIP = null;
            //    return false;
            //}
            //int ConnectionID = GetFreeConnectionID();
            //if (ConnectionID < 0)
            //    return false;
            //else
            //    mConnectionStorage[ConnectionID] = SocketIP;

            //SocketIP = null;
        }

        private static int GetConnectionAmount(string IP)
        {
            if (!mConnectionStorage.ContainsKey(IP))
                return 0;
            else
                return mConnectionStorage[IP];
            //int Count = 0;
            //for (int i = 0; i < mMaxLoad; i++)
            //{
            //    if (mConnectionStorage[i] == IP)
            //        Count++;
            //}

            //return Count;
        }

        internal static void FreeConnection(string IP)
        {
            int ConnectionAmount = GetConnectionAmount(IP) - 1;
            mConnectionStorage.Remove(IP);
            if (ConnectionAmount > 0)
            {
                mConnectionStorage.Remove(IP);
                mConnectionStorage.Add(IP, ConnectionAmount);
            }

            //for (int i = 0; i < mConnectionStorage.Length; i++)
            //{
            //    if (mConnectionStorage[i] == IP)
            //    {
            //        mConnectionStorage[i] = null;
            //        break;
            //    }
            //}
        }
        //private static int GetFreeConnectionID()
        //{
        //    for (int i = 0; i < mConnectionStorage.Length; i++)
        //    {
        //        if (mConnectionStorage[i] == null)
        //        {
        //            if (i > mMaxLoad)
        //                mMaxLoad = i;
        //            return i;
        //        }
        //    }
        //    return -1;
        //}

    }
}
